#ifndef MAINSERVERWINDOW_H
#define MAINSERVERWINDOW_H

#include <QMainWindow>
#include <QSystemTrayIcon>
#include "nntpgrab_qt.h"

namespace Ui {
    class MainServerWindow;
}

class MainServerWindow : public QMainWindow {
    Q_OBJECT
public:
    MainServerWindow(QWidget *parent = 0);
    ~MainServerWindow();

protected:
    void changeEvent(QEvent *e);
#ifdef Q_WS_WIN
    bool winEvent(MSG* msg, long* result);
#elif defined(Q_WS_X11)
    void hideEvent(QHideEvent *e);
#endif

    QNNTPGrab nntpgrab;
    QSystemTrayIcon trayIcon;

private:
    Ui::MainServerWindow *ui;

private slots:
    void on_btnExit_clicked();
    void on_btnPauseSchedular_clicked();

    void onPluginEvent(QString plugin_name, QString event_name, QList<QString> values);
    void onSchedularStateChanged(QNNTPGrab::SchedularState new_state, QString reason);
    void onQuitRequestReceived(void);
    void onLogMessage(QString component, QNNTPGrab::LogLevel log_level, QString message);

    void initNNTPGrab();

#ifndef Q_OS_DARWIN
    void trayIconActivated(QSystemTrayIcon::ActivationReason);
#endif
};

#endif // MAINSERVERWINDOW_H
